/*
 * Navrhněte funkci calculate, která má dva parametry (arg1, arg2) typu double a třetí parametr(fun) je ukazatel na
 * funkci, která má dva argumenty typu double a návratová hodnota je double. Funkce calculate() také
 * vrací hodnotu typu double, kterou vrátí fun(arg1, arg2).
 *
 * Příklad:

 * double add(double x, double y)
 * {
 * return x + y;
 * }
 * double q = calculate(2.5, 10.4, add); // q = 12.9

 */
#include <vector>
#include <iostream>

using namespace std;
double calculate(double arg1, double arg2, double (*fun)(double, double)) {
    return fun(arg1, arg2);
}

double (*calculate(double arg1, double arg2, double (*fun)(double, double)))(double, double){

}

/*
 * Upravte funkci calculate(calculate_add_vec) tak, aby její třetí parametr byl vector funkcí stejného typu jako fun.
 * Postupně se zavolá každá funkce ve vektoru s parametry arg1, arg2 a výsledky se sečtou.
 * Bude tedy platit: calculate(arg1, arg2, add) == calculate_add_vec(arg1, arg2, vec) // iff add e vec ^ vec.size==1
 */

typedef double (*PF) (double, double);

double calculate_add_vec(double arg1, double arg2, vector<PF> &f_vec) {
    vector<PF>::const_iterator f_it = f_vec.begin();
    double sum = 0;
    while(f_it!=f_vec.end()) {
        sum+=(*f_it)(arg1, arg2);
        f_it++;
    }
    return sum;
}

/* Zobecněte funkci  calculate_add_vec (calculate_fun_vec) tak, aby její čtvrý parametr(op) byl typu jako fun a pátý parametr typu
 * double (neutral) - neutrální prvek operace op. Pokud není pátý parametr předán, pak je implicitně 0.0.
 * Funkce calculate_fun_vec bude pracovat stejně jako calculate_add_vec, ale místo sčítání se použije op.
 * Bude tedy platit: calculate_add_vec(arg1, arg2, vec) == calculate_fun_vec(arg1, arg2, vec, add, 0.0)
 */

double calculate_fun_vec(double arg1, double arg2, vector<PF> &f_vec, PF op, double neutral = 0.0) {
    vector<PF>::const_iterator f_it = f_vec.begin();
    double sum = neutral;
    while(f_it!=f_vec.end()) {
        sum=op(sum, (*f_it)(arg1, arg2));
        f_it++;
    }
    return sum;
}


double add(double a, double b) {
    return a + b;
}


int main(void) {
    vector<PF> vec;
    vec.push_back(add);
    vec.push_back(add);
    vec.push_back(add);
    cout << calculate_add_vec(1.0, 1.0, vec) << endl;
    cout << calculate_fun_vec(1.0, 1.0, vec, add, 0.0) << endl;
    return 0;
}
